Unit qsf2e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS12_p;

procedure qsf2e(var INT1 :Extended; var INT2 :Extended; var A :Extended;
                var B :Extended; F :Func_F1E; RO :Extended; FI :Extended;
                E :Extended; L1 :Integer; L2 :Integer);

implementation

procedure qsf2e(var INT1 :Extended; var INT2 :Extended; var A :Extended;
                var B :Extended; F :Func_F1E; RO :Extended; FI :Extended;
                E :Extended; L1 :Integer; L2 :Integer);
var
D,IERR :Integer;
R1,R2 :Real;
I,K,C,W,Z2,EPS,H,Z1,P,R,Q,V,T,S,U,Z,BA,BB,BD,X,Y :Extended;
NI :Boolean;
G :Array [0..4] of Extended;
L :Array [0..4] of Extended;
M :Array [0..4] of Extended;
Q1 :Array [0..4] of Extended;
BC :Array [0..6] of Extended;
const
TDS :Extended = 0.2666666666666667e0;
TSO :Extended = 0.7111111111111111e0;
TOF :Extended = 0.1555555555555556e0;
SYS051 :Extended = 1.1107652e-16;
HMIN :Extended = 1.192093e-4;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_11,_12,_13,_14,_15,_16,_17,_18,_19,_22,
_20,_21;
begin
NI := ( A  > B );
if (  not ( (NI) ) ) 
 then goto _1;
C := A;
A := B;
B := C;
_1:
W := B-A;
if (  not ( (W  = 0.e0) ) ) 
 then goto _2;
INT1 := 0.e0;
INT2 := 0.e0;
goto _21;
_2:
Z2 := E/W;
EPS := Abs(E);
H := 1.e0;
Z1 := EPS/W;
P := 0.e0;
INT1 := 0.e0;
INT2 := 0.e0;
_3:
R := H/2.e0;
Q := W*R;
V := Q*RO;
T := H*0.25e0;
for D:=1 to 5 do
 begin
  L[D-1] := F(A+W*(P+T*(D-1)));
_4:
 end;
_5:
if ( (L1+L2)  < 1.5e0  ) and ( V  <= 0.25e0 ) 
 then goto _6;
S := Abs(L[0]+L[4]-4.e0*(L[1]+L[3])+6.e0*L[2]);
goto _8;
_6:
I := (A+W*(P+R))*RO+FI;
for D:=1 to 5 do
 begin
  M[D-1] := L[D-1]*Sin(I);
  Q1[D-1] := L[D-1]*Cos(I);
_7:
 end;
I := M[0]+M[4]-4.e0*(M[1]+M[3])+6.e0*M[2];
S := Q1[0]+Q1[4]-4.e0*(Q1[1]+Q1[3])+6.e0*Q1[2];
S := EMax1((L1)*Abs(I),(L2)*Abs(S));
_8:
S := S*R*0.42e0;
if ( H  < HMIN ) 
 then goto _22;
if ( Abs(S)-Z1 ) < 0
 then goto _12
 else if ( Abs(S)-Z1 ) > 0
       then goto _9
       else goto _9;
_9:
H := H/2;
if ( H-SYS051*P ) < 0
 then goto _22
 else if ( H-SYS051*P ) > 0
       then goto _11
       else goto _22;
_11:
L[4] := L[2];
L[2] := L[1];
R := H*0.5e0;
V := W*R*RO;
T := H*0.25e0;
U := P+T;
L[1] := F(A+W*U);
L[3] := F(A+W*(U+R));
goto _5;
_12:
I := (A+W*(P+R))*RO+FI;
Z := Sin(I);
BA := Cos(I);
Q := W*R;
BB := RO*Q;
BC[3] := Sin(BB);
BC[4] := Cos(BB);
if ( BB-0.33e0 ) < 0
 then goto _13
 else if ( BB-0.33e0 ) > 0
       then goto _14
       else goto _13;
_13:
BD := BB*0.5e0;
BC[5] := Sin(BD);
BC[6] := Cos(BD);
G[0] := TDS;
G[1] := TSO*BC[6];
G[2] := TOF*BC[4];
G[3] := TSO*BC[5];
G[4] := TOF*BC[3];
goto _15;
_14:
BC[0] := 1.e0/BB;
BC[1] := BC[0]*BC[0];
BC[2] := BC[1]*BC[1];
G[0] := 4.e0*BC[1]*(BC[0]*(48.e0*BC[1]-19.e0)*BC[3]+3.e0*(1.e0-
    16.e0*BC[1])*BC[4]);
G[1] := 32.e0*BC[1]*(BC[0]*(5.e0-12.e0*BC[1])*BC[3]-(1.e0-12.e0*
    BC[1])*BC[4])/3.e0;
G[2] := BC[0]*((3.e0-46.e0*BC[1]+96.e0*BC[2])*BC[3]+2.e0*BC[0]*
    (7.e0-48.e0*BC[1])*BC[4])/3.e0;
G[3] := -16.e0*BC[1]*((1.e0-3.e0*BC[1])*BC[3]+3.e0*BC[0]*BC[4])/
    3.e0;
G[4] := BC[0]*(BC[0]*(11.e0-24.e0*BC[1])*BC[3]-3.e0*(1.e0-8.e0*
    BC[1])*BC[4])/3.e0;
_15:
X := G[0]*L[2]+G[1]*(L[1]+L[3])+G[2]*(L[0]+L[4]);
Y := G[3]*(L[3]-L[1])+G[4]*(L[4]-L[0]);
R1 := (Z*X+BA*Y)*R;
R2 := (BA*X-Z*Y)*R;
INT1 := INT1+R1;
INT2 := INT2+R2;
if ( P  = P+H ) 
 then goto _22;
P := P+H;
K := 1.e0-P;
if ( K  <= 0.0e0 ) 
 then goto _20;
_16:
L[0] := L[4];
if ( Abs(S)-Z1/32.e0 ) < 0
 then goto _17
 else if ( Abs(S)-Z1/32.e0 ) > 0
       then goto _18
       else goto _18;
_17:
H := 2*H;
_18:
if ( H-K ) < 0
 then goto _3
 else if ( H-K ) > 0
       then goto _19
       else goto _3;
_19:
H := K;
goto _3;
_22:
IERR := 65;
UTQS12(IERR,13) ;
_20:
INT1 := INT1*W;
INT2 := INT2*W;
if (  not ( (NI) ) ) 
 then goto _21;
C := B;
B := A;
A := C;
_21:
end;

end.
